import { TemplateRef, ComponentFactoryResolver, ApplicationRef, Injector, OnInit, AfterViewInit } from '@angular/core';
import { WalkthroughContainerComponent } from './walkthrough-container.component';
import { WalkthroughService } from './walkthrough.service';
import { WalkthroughText } from './walkthrough-text';
export interface WalkthroughElementCoordinate {
    top: number;
    left: number;
    height: number;
    width: number;
}
export declare class WalkthroughComponent implements OnInit, AfterViewInit {
    private _componentFactoryResolver;
    private _applicationRef;
    private _injector;
    private _walkthroughService;
    private static _walkthroughContainer;
    private static _walkthroughContainerCreating;
    focusElementSelector: string;
    typeSelector: 'element' | 'zone';
    focusClick: (event: Event, content: WalkthroughContainerComponent) => {};
    radius: string;
    previousStep: WalkthroughComponent;
    nextStep: WalkthroughComponent;
    texts: WalkthroughText;
    contentTemplate: TemplateRef<any>;
    contentText: string;
    contentStyle: 'none' | 'draken';
    arrowColor: string;
    id: string;
    justifyContent: 'left' | 'center' | 'right';
    closeButton: string | boolean;
    closeAnywhere: string | boolean;
    showArrow: string | boolean;
    finishStep: string | boolean;
    focusHighlightAnimation: string | boolean;
    focusBackdrop: string | boolean;
    focusGlow: string | boolean;
    private _id;
    private _uid;
    private _show;
    private _hasHighlightAnimation;
    private _hasBackdrop;
    private _hasGlow;
    private _hasFinish;
    private _hasArrow;
    private _hasCloseButton;
    private _hasCloseAnywhere;
    private _justifyContent;
    private _focusElement;
    private _focusElementEnd;
    private _offsetCoordinates;
    constructor(_componentFactoryResolver: ComponentFactoryResolver, _applicationRef: ApplicationRef, _injector: Injector, _walkthroughService: WalkthroughService);
    resize(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    open(): void;
    loadPrevioustStep(): void;
    loadNextStep(): void;
    show(): void;
    hide(): void;
    private _appendComponentToBody<T>(component);
    private _attachWalkthroughContent<T>(componentOrTemplateRef, walkthroughContainer);
    private _elementLocations();
    /**
     *
     */
    private _getFocusElement();
    /**
     * get instance, hightlight the focused element et show the template
     */
    private _setFocus();
    private _updateElementPositions(instance);
    /**
     * Attache the template in the contener, if a template is linked.
     */
    private _attachContentTemplate();
    /**
     * init all datas of the contenaire
     */
    private _initContentTemplate(instance);
}
